Package groovy.util.slurpersupport

## Class NodeChildren

- java.lang.Object
- - groovy.lang.GroovyObjectSupport
  - - groovy.util.slurpersupport.GPathResult
    - - groovy.util.slurpersupport.NodeChildren

- All Implemented Interfaces:
    `Buildable`, `GroovyObject`, `Writable`, `java.lang.Iterable`
  Direct Known Subclasses:
    `Attributes`, `FilteredNodeChildren`, `NodeParents`

      public class NodeChildren
      extends GPathResult

  Lazy evaluated representation of child nodes.

- - ### Field Summary

    - ### Fields inherited from class groovy.util.slurpersupport.GPathResult

      `name, namespaceMap, namespacePrefix, namespaceTagHints, parent`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `NodeChildren​(GPathResult parent, java.lang.String name, java.lang.String namespacePrefix, java.util.Map<java.lang.String,​java.lang.String> namespaceTagHints)` |
    `NodeChildren​(GPathResult parent, java.lang.String name, java.util.Map<java.lang.String,​java.lang.String> namespaceTagHints)` |
    `NodeChildren​(GPathResult parent, java.util.Map<java.lang.String,​java.lang.String> namespaceTagHints)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected void` | `appendNode​(java.lang.Object newValue)` |
    `void` | `build​(GroovyObject builder)` |
    `java.util.Iterator` | `childNodes()` | Returns an iterator over the child nodes of this GPathResult.
    `GPathResult` | `find​(Closure closure)` | Returns the first child of this GPathResult matching the condition(s) specified in the passed closure.
    `GPathResult` | `findAll​(Closure closure)` | Returns the children of this GPathResult matching the condition(s) specified in the passed closure.
    `java.util.Iterator` | `iterator()` |
    `java.util.Iterator` | `nodeIterator()` |
    `GPathResult` | `parents()` | Throws a `GroovyRuntimeException`, because it is not implemented yet.
    `protected void` | `replaceBody​(java.lang.Object newValue)` |
    `protected void` | `replaceNode​(Closure newValue)` |
    `int` | `size()` | Returns the size of this GPathResult.
    `java.lang.String` | `text()` | Returns the text of this GPathResult as a `String`.
    `java.io.Writer` | `writeTo​(java.io.Writer out)` | Writes this object to the given writer.

    - ### Methods inherited from class groovy.util.slurpersupport.GPathResult

      `breadthFirst, children, createIterator, declareNamespace, depthFirst, equals, getAt, getAt, getBody, getProperty, hashCode, isEmpty, leftShift, list, lookupNamespace, name, parent, plus, pop, putAt, setMetaClass, setProperty, toBigDecimal, toBigInteger, toBoolean, toDouble, toFloat, toInteger, toLong, toString, toURI, toURL`

    - ### Methods inherited from class groovy.lang.GroovyObjectSupport

      `getMetaClass, invokeMethod`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

- - ### Constructor Detail

    - #### NodeChildren

          public NodeChildren​(GPathResult parent,
                              java.lang.String name,
                              java.lang.String namespacePrefix,
                              java.util.Map<java.lang.String,​java.lang.String> namespaceTagHints)

      Parameters:
        `parent` - the GPathResult prior to the application of the expression creating this GPathResult
        `name` - if the GPathResult corresponds to something with a name, e.g. a node
        `namespacePrefix` - the namespace prefix if any
        `namespaceTagHints` - the known tag to namespace mappings

    - #### NodeChildren

          public NodeChildren​(GPathResult parent,
                              java.lang.String name,
                              java.util.Map<java.lang.String,​java.lang.String> namespaceTagHints)

      Parameters:
        `parent` - the GPathResult prior to the application of the expression creating this GPathResult
        `name` - if the GPathResult corresponds to something with a name, e.g. a node
        `namespaceTagHints` - the known tag to namespace mappings

    - #### NodeChildren

          public NodeChildren​(GPathResult parent,
                              java.util.Map<java.lang.String,​java.lang.String> namespaceTagHints)

      Parameters:
        `parent` - the GPathResult prior to the application of the expression creating this GPathResult
        `namespaceTagHints` - the known tag to namespace mappings

  - ### Method Detail

    - #### childNodes

          public java.util.Iterator childNodes()

      Description copied from class: `GPathResult`
      Returns an iterator over the child nodes of this GPathResult.
      Specified by:
        `childNodes` in class `GPathResult`
      Returns:
        an iterator over the child nodes of this GPathResult

    - #### iterator

          public java.util.Iterator iterator()

      Specified by:
        `iterator` in interface `java.lang.Iterable`
      Specified by:
        `iterator` in class `GPathResult`

    - #### nodeIterator

          public java.util.Iterator nodeIterator()

      Specified by:
        `nodeIterator` in class `GPathResult`

    - #### parents

          public GPathResult parents()

      Throws a `GroovyRuntimeException`, because it is not implemented yet.
      Specified by:
        `parents` in class `GPathResult`
      Returns:
        the parents of this GPathResult

    - #### size

          public int size()

      Description copied from class: `GPathResult`
      Returns the size of this GPathResult.
      Specified by:
        `size` in class `GPathResult`
      Returns:
        the size of this GPathResult

    - #### text

          public java.lang.String text()

      Description copied from class: `GPathResult`
      Returns the text of this GPathResult as a `String`.
      Specified by:
        `text` in class `GPathResult`
      Returns:
        the text of this GPathResult

    - #### find

          public GPathResult find​(Closure closure)

      Description copied from class: `GPathResult`
      Returns the first child of this GPathResult matching the condition(s) specified in the passed closure.
      Specified by:
        `find` in class `GPathResult`
      Parameters:
        `closure` - a closure to filters the children of this GPathResult
      Returns:
        the first child matching the closure

    - #### findAll

          public GPathResult findAll​(Closure closure)

      Description copied from class: `GPathResult`
      Returns the children of this GPathResult matching the condition(s) specified in the passed closure.
      Specified by:
        `findAll` in class `GPathResult`
      Parameters:
        `closure` - a closure to filters the children of this GPathResult
      Returns:
        the children matching the closure

    - #### build

          public void build​(GroovyObject builder)

    - #### writeTo

          public java.io.Writer writeTo​(java.io.Writer out)
                                 throws java.io.IOException

      Description copied from interface: `Writable`
      Writes this object to the given writer.

      This is used to defer content creation until the point when it is streamed to the output destination. Oftentimes, content will be defined but not necessarily created (as is may be the case with a Closure definition.) In that case, the output is then 'deferred' to the point when it is serialized to the writer. This class may be used whenever an object should be responsible for creating its own textual representation, but creating the entire output as a single String would be inefficient (such as outputting a multi-gigabyte XML document.)

      Parameters:
        `out` - the Writer to which this Writable should output its data.
      Returns:
        the Writer that was passed
      Throws:
        `java.io.IOException` - if an error occurred while outputting data to the writer

    - #### replaceNode

          protected void replaceNode​(Closure newValue)

      Specified by:
        `replaceNode` in class `GPathResult`

    - #### replaceBody

          protected void replaceBody​(java.lang.Object newValue)

      Specified by:
        `replaceBody` in class `GPathResult`

    - #### appendNode

          protected void appendNode​(java.lang.Object newValue)

      Specified by:
        `appendNode` in class `GPathResult`